﻿Public Class AccountInformationForm

   Private clients(0 To 7) As Client ' Client object
   Private position As Integer = 0 ' current account

   ' create array of Client objects
   Private Sub AccountInformationForm_Load(ByVal sender As  _
      System.Object, ByVal e As System.EventArgs) _
      Handles MyBase.Load

      Dim count As Integer ' counter variable

      ' array of first names
      Dim firstName() As String = _
         New String() {"John", "Sarah", "Jack", "Adam", "Diane", _
            "David", "Kristin", "Jennifer"}

      ' array of last names
      Dim lastName() As String = _
         New String() {"Blue", "White", "Red", "Brown", _
            "Yellow", "Black", "Green", "Orange"}

      'array of account numbers 
      Dim account() As Integer = _
         New Integer() {1234652, 1234666, 1234678, 1234681, _
            1234690, 1234770, 1234787, 1234887}

      ' array of account balances
      Dim balance() As Decimal = _
         New Decimal() {Convert.ToDecimal(1000.78), _
            Convert.ToDecimal(2056.24), Convert.ToDecimal(978.65), _
            Convert.ToDecimal(990.0), Convert.ToDecimal(432.75), _
            Convert.ToDecimal(780.78), Convert.ToDecimal(4590.63), _
            Convert.ToDecimal(7910.11)}

      ' loop and create 10 Client objects
      For count = 0 To clients.GetUpperBound(0)
         ' create new object and store into Client array
         clients(count) = New Client(firstName(count), _
            lastName(count), account(count), balance(count))
      Next
   End Sub ' AccountInformationForm_Load

   ' display next object
   Private Sub nextButton_Click(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles nextButton.Click

      position += 1 ' increment position

      ' if position is last (top) object
      If position > clients.GetUpperBound(0) Then
         position = 0 ' set to first position in array
         DisplayInformation() ' display information
      Else
         DisplayInformation()
      End If
   End Sub ' nextButton_Click

   ' display previous object
   Private Sub preveiousButton_Click(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles previousButton.Click

      position -= 1 ' decrement position

      ' if position is last (bottom) object
      If position < 0 Then
         ' set to last position in array
         position = clients.GetUpperBound(0)
         DisplayInformation()
      Else
         DisplayInformation() ' display information
      End If
   End Sub ' previousButton_Click

   ' display information
   Private Sub DisplayInformation()
      ' use Position as index for each object
      firstTextBox.Text = clients(position).First
      lastTextBox.Text = clients(position).Last
      accountTextBox.Text = _
         Convert.ToString(clients(position).Account)

      ' format as currency
      balanceTextBox.Text = _
         String.Format("{0:C}", clients(position).Balance)
   End Sub ' DisplayInformation
End Class ' AccountInformationForm

' **************************************************************************
' * (C) Copyright 1992-2009 by Deitel & Associates, Inc. and               *
' * Pearson Education, Inc. All Rights Reserved.                           *
' *                                                                        *
' * DISCLAIMER: The authors and publisher of this book have used their     *
' * best efforts in preparing the book. These efforts include the          *
' * development, research, and testing of the theories and programs        *
' * to determine their effectiveness. The authors and publisher make       *
' * no warranty of any kind, expressed or implied, with regard to these    *
' * programs or to the documentation contained in these books. The authors *
' * and publisher shall not be liable in any event for incidental or       *
' * consequential damages in connection with, or arising out of, the       *
' * furnishing, performance, or use of these programs.                     *
' **************************************************************************