﻿Public Class MicrowaveOvenForm

   ' contains time entered as a String
   Private timeIs As String = ""

   ' holds the time
   Private timeObject As Time

   ' event handler appends 1 to time string
   Private Sub oneButton_Click(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles oneButton.Click

      Beep() ' sound beep
      timeIs &= "1" ' append digit to time input
      DisplayTime() ' display time input properly
   End Sub ' oneButton_Click

   ' event handler appends 2 to time string
   Private Sub twoButton_Click(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles twoButton.Click

      Beep() ' sound beep
      timeIs &= "2" ' append digit to time input
      DisplayTime() ' display time input properly
   End Sub ' twoButton_Click

   ' event handler appends 3 to time string
   Private Sub threeButton_Click(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles threeButton.Click

      Beep() ' sound beep
      timeIs &= "3" ' append digit to time input
      DisplayTime() ' display time input properly
   End Sub ' threeButton_Click

   ' event handler appends 4 to time string
   Private Sub fourButton_Click(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles fourButton.Click

      Beep() ' sound beep
      timeIs &= "4" ' append digit to time input
      DisplayTime() ' display time input properly
   End Sub ' fourButton_Click

   ' event handler appends 5 to time string
   Private Sub fiveButton_Click(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles fiveButton.Click

      Beep() ' sound beep
      timeIs &= "5" ' append digit to time input
      DisplayTime() ' display time input properly
   End Sub ' fiveButton_Click

   ' event handler appends 6 to time string
   Private Sub sixButton_Click(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles sixButton.Click

      Beep() ' sound beep
      timeIs &= "6" ' append digit to time input
      DisplayTime() ' display time input properly
   End Sub ' sixButton_Click

   ' event handler appends 7 to time string
   Private Sub sevenButton_Click(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles sevenButton.Click

      Beep() ' sound beep
      timeIs &= "7" ' append digit to time input
      DisplayTime() ' display time input properly
   End Sub ' sevenButton_Click

   ' event handler appends 8 to time string
   Private Sub eightButton_Click(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles eightButton.Click

      Beep() ' sound beep
      timeIs &= "8" ' append digit to time input
      DisplayTime() ' display time input properly
   End Sub ' eightButton_Click

   ' event handler appends 9 to time string
   Private Sub nineButton_Click(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles nineButton.Click

      Beep() ' sound beep
      timeIs &= "9" ' append digit to time input
      DisplayTime() ' display time input properly
   End Sub ' nineButton_Click

   ' event handler appends 0 to time string
   Private Sub zeroButton_Click(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles zeroButton.Click

      Beep() ' sound beep
      timeIs &= "0" ' append digit to time input
      DisplayTime() ' display time input properly
   End Sub ' zeroButton_Click

   ' event handler starts the microwave oven's cooking process
   Private Sub startButton_Click(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles startButton.Click

      Dim second As Integer
      Dim minute As Integer

      ' pad extra spaces with "0"
      timeIs = timeIs.PadLeft(4, Convert.ToChar("0"))

      ' extract seconds, minutes and hours
      second = Convert.ToInt32(timeIs.Substring(3))
      minute = Convert.ToInt32(timeIs.Substring(0, 2))

      ' create Time object to contain time entered by user
      timeObject = New Time(minute, second)

      ' display the time
      displayLabel.Text = String.Format("{0:D2}:{1:D2}", _
         timeObject.Minute, timeObject.Second)

      timeIs = "" ' clear m_strTime for future input
      clockTimer.Enabled = True            ' begin timer
      windowPanel.BackColor = Color.Yellow ' turn "light" on
   End Sub ' startButton_Click

   ' event handler to clear input
   Private Sub clearButton_Click(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles clearButton.Click

      ' reset each method or variable to its initial setting
      displayLabel.Text = "Microwave Oven"
      timeIs = ""
      timeObject = New Time(0, 0)
      clockTimer.Enabled = False           ' turn timer off
      windowPanel.BackColor = Control.DefaultBackColor

      startButton.Enabled = True ' enable Start Button
   End Sub ' clearButton_Click

   ' method to display formatted time in timer window
   Private Sub DisplayTime()

      Dim second As Integer
      Dim minute As Integer
      Dim display As String ' the display String

      ' if too much input entered
      If timeIs.Length > 4 Then
         timeIs = timeIs.Substring(0, 4)
      End If

      ' pad the empty spaces of the display String with "0"
      display = timeIs.PadLeft(4, Convert.ToChar("0"))

      ' extract seconds and minutes and hours
      second = Convert.ToInt32(display.Substring(3))
      minute = Convert.ToInt32(display.Substring(0, 2))

      ' display number of hours, minutes, and seconds
      displayLabel.Text = String.Format("{0:D2}:{1:D2}", _
         minute, second)
   End Sub ' DisplayTime

   ' event handler displays new time each second
   Private Sub clockTimer_Tick(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles clockTimer.Tick

      ' perform countdown, subtract one second
      If timeObject.Second > 0 Then
         timeObject.Second -= 1
      ElseIf timeObject.Minute > 0 Then
         timeObject.Minute -= 1 ' subtract one minute
         timeObject.Second = 59 ' reset seconds for new minute
      Else ' no more seconds
         clockTimer.Enabled = False           ' stop the timer
         Beep()                             ' sound beep
         displayLabel.Text = "Done!"          ' display "Done" message
         windowPanel.BackColor = Control.DefaultBackColor

         Return
      End If

      ' refresh the display time
      displayLabel.Text = String.Format("{0:D2}:{1:D2}", _
         timeObject.Minute, timeObject.Second)
   End Sub ' clockTimer_Tick
End Class ' MicrowaveOvenForm
' **************************************************************************
' * (C) Copyright 1992-2009 by Deitel & Associates, Inc. and               *
' * Pearson Education, Inc. All Rights Reserved.                           *
' *                                                                        *
' * DISCLAIMER: The authors and publisher of this book have used their     *
' * best efforts in preparing the book. These efforts include the          *
' * development, research, and testing of the theories and programs        *
' * to determine their effectiveness. The authors and publisher make       *
' * no warranty of any kind, expressed or implied, with regard to these    *
' * programs or to the documentation contained in these books. The authors *
' * and publisher shall not be liable in any event for incidental or       *
' * consequential damages in connection with, or arising out of, the       *
' * furnishing, performance, or use of these programs.                     *
' **************************************************************************